clear all; clc; close all;
% tic
exampleDataDir = '.\data';
libDir = '.\libfiles';

% celStruct = affyread(fullfile(exampleDataDir,'GSM1406033_Control-015_HG-U133_Plus_2_.CEL'));
% celFigure = figure;
% maimage(celStruct)
% cdfStruct = affyread('HG-U133_Plus_2.cdf',libDir);
% cdfStruct.ProbeSets
% probeSetIndex = 5213;
% cdfStruct.ProbeSets(probeSetIndex)
% cdfStruct.ProbeSetColumnNames
% cdfStruct.ProbeSets(probeSetIndex).ProbePairs
% PMX = cdfStruct.ProbeSets(probeSetIndex).ProbePairs(1,3);
% PMY = cdfStruct.ProbeSets(probeSetIndex).ProbePairs(1,4);
% theProbe = find((celStruct.Probes(:,1) == PMX) & ...
%                        (celStruct.Probes(:,2) == PMY));
% celStruct.Probes(theProbe,:)
% probeinfo = probelibraryinfo(celStruct,cdfStruct);
% probeinfo(theProbe,:)
% 
% probeName = cdfStruct.ProbeSets(probeSetIndex).Name;
% psvals = probesetvalues(celStruct,cdfStruct,probeName);
% sprintf( ['%4d %2d %d %d  PM: %3d %3d %5.1f %5.1f %2d %d %d',...
%           '  MM: %3d %3d %5.1f %5.1f %2d %d %d %d %d\n'],psvals')
%       
% pmIntensity = psvals(:,7);
% mmIntensity = psvals(:,14);
% boxplot([pmIntensity,mmIntensity],'labels',{'Perfect Match','Mismatch'})
% title(sprintf('Boxplot of raw intensity values for probe set %s',...
%     probeName),'interpreter','none')
% 
% figure
% plot(pmIntensity,'b'); hold on
% plot(mmIntensity,'r'); hold off
% title(sprintf('Probe intensity values for probe set %s',...
%     probeName),'interpreter','none')
% 
% probesetplot(celStruct,cdfStruct,probeName,'showstats',true);
% 
% ginStruct = affyread('HG-U133_Plus_2.gin',libDir);
% info = probesetlookup(cdfStruct,probeName);

fid = fopen('note.txt','r');
ftext = textscan(fid,'%q%q');
fclose(fid);
samples = ftext{1};
cels = ftext{2};

celPath = exampleDataDir;
libPath = libDir;
probeData = celintensityread(cels, 'HG-U133_Plus_2.cdf',...
                 'celpath', celPath, 'cdfpath', libPath, 'pmonly', false);
nSamples = probeData.NumChips;
nProbeSets = probeData.NumProbeSets;
nProbes = probeData.NumProbes;

seqPath = '.\libfiles';
S = affyprobeseqread('HG-U133_Plus_2_probe_tab', 'HG-U133_Plus_2.cdf',...
                'seqpath', seqPath, 'cdfpath', libPath, 'seqonly', true);
            
pms_bg = rmabackadj(probeData.PMIntensities, 'showplot', 1);
pms_bgnorm = quantilenorm(pms_bg);
cns_rma_exp = rmasummary(probeData.ProbeIndices, pms_bgnorm);

figure
idx = find(strcmpi('BLOOD_Control_Rep1', samples));
[pmAlpha, mmAlpha] = affyprobeaffinities(S.SequenceMatrix,...
                       probeData.MMIntensities(:, idx), 'showplot', true);
                   
cns_mle_exp = gcrma(probeData.PMIntensities, probeData.MMIntensities,...
                    probeData.ProbeIndices, pmAlpha, mmAlpha);
                   
cns_EB_exp = gcrma(probeData.PMIntensities, probeData.MMIntensities,...
                    probeData.ProbeIndices, pmAlpha, mmAlpha,'Method','EB');
                
import bioma.data.*
expr_cns_rma = DataMatrix(cns_rma_exp, probeData.ProbeSetIDs, samples');
expr_cns_gcrma_eb = DataMatrix(cns_EB_exp, probeData.ProbeSetIDs, samples');
expr_cns_gcrma_mle = DataMatrix(cns_mle_exp, probeData.ProbeSetIDs, samples');

load HUG133_plus_2_GeneSymbol_Map

expr = expr_cns_gcrma_eb; %
huGenes = values(HUG133plus2_GeneSymbol_Map, expr.RowNames);
expr = rownames(expr, ':', huGenes);
expr('---', :) = [];

[mask, expr] = genelowvalfilter(expr);
[mask, expr] = genevarfilter(expr);
nGenes = expr.NRows
ctrl = expr(:,1:23);
first = expr(:,24:46);
second = expr(:,47:69);
third = expr(:,70:92);
[pvalues, tscores] = mattest(ctrl, first,...
                                'Showhist', true', 'Showplot', true);
% all_possible_perms = nchoosek(1:ctrl.NCols+first.NCols, ctrl.NCols);
% size(all_possible_perms, 1)
pvaluesCorr = mattest(ctrl, first, 'Permute', 10000);
cutoff = 0.05;
sum(pvaluesCorr < cutoff)
figure;
[pFDR, qvalues] = mafdr(pvaluesCorr, 'showplot', true);
sum(qvalues < cutoff)
pvaluesBH = mafdr(pvaluesCorr, 'BHFDR', true);
sum(pvaluesBH < cutoff)
testResults = [tscores pvaluesCorr pFDR qvalues pvaluesBH];
testResults = colnames(testResults, 5, {'FDR_BH'});
testResults = sortrows(testResults, 2);
testResults(1:23, :)
diffStruct = mavolcanoplot(ctrl, first, pvaluesCorr)
nDiffGenes = diffStruct.PValues.NRows
up_geneidx = find(diffStruct.FoldChanges > 0);
up_genes = rownames(diffStruct.FoldChanges, up_geneidx);
nUpGenes = length(up_geneidx)
nDownGenes = sum(diffStruct.FoldChanges < 0)
huGenes = rownames(expr);
for i = 1:nUpGenes
    up_geneidx(i) = find(strncmpi(huGenes, up_genes{i}, length(up_genes{i})), 1);
end
GO = geneont('live',true);
HGann = goannotread('gene_association.goa_human',...
    'Aspect','P','Fields',{'DB_Object_Symbol','GOid'});
HGmap = containers.Map();
for i = 1:numel(HGann)
    key = HGann(i).DB_Object_Symbol;
    if isKey(HGmap,key)
        HGmap(key) = [HGmap(key) HGann(i).GOid];
    else
        HGmap(key) = HGann(i).GOid;
    end
end
HGmap.Count
m = GO.Terms(end).id;        % gets the last term id
chipgenesCount = zeros(m,1); % a vector of GO term counts for the entire chip.
upgenesCount  = zeros(m,1);  % a vector of GO term counts for up-regulated genes.
for i = 1:length(huGenes)
    if isKey(HGmap,huGenes{i})
        goid = getrelatives(GO,HGmap(huGenes{i}));
        % Update the tally
        chipgenesCount(goid) = chipgenesCount(goid) + 1;
        if (any(i == up_geneidx))
            upgenesCount(goid) = upgenesCount(goid) +1;
        end
    end
end
gopvalues = hygepdf(upgenesCount,max(chipgenesCount),...
                        max(upgenesCount),chipgenesCount);
[dummy, idx] = sort(gopvalues);

report = sprintf('GO Term     p-value     counts      definition\n');
for i = 1:10
    term = idx(i);
    report = sprintf('%s%s\t%-1.5f\t%3d / %3d\t%s...\n',...
             report, char(num2goid(term)), gopvalues(term),...
             upgenesCount(term), chipgenesCount(term),...
            GO(term).Term.definition(2:min(50,end)));
end
disp(report);

fcnAncestors = GO(getancestors(GO,idx(1:5)))
[cm,acc,rels] = getmatrix(fcnAncestors);
BG = biograph(cm,get(fcnAncestors.Terms,'name'))

for i = 1:numel(acc)
    pval = gopvalues(acc(i));
    color = [(1-pval).^(1) pval.^(1/8) pval.^(1/8)];
    BG.Nodes(i).Color = color;
end
view(BG)
% MaxMean Collapse
Genes = expr.RowNames;
[uniGenes,ia,ic] = unique(Genes);
expr_uni = [];
parfor i = 1:length(uniGenes)
    ind = find(ic==i);
    if length(ind) == 1
        expr_uni = [expr_uni;expr.(ind)(':')'];
    else
        [M,I] = max(mean(expr.(ind)(':'),2));
        expr_uni = [expr_uni;expr.(ind(I))(':')'];
    end
end
expr_uni = DataMatrix(expr_uni, uniGenes, samples');
% toc